// Copyright Earl Warren <contact@earl-warren.org>
// Copyright Loïc Dachary <loic@dachary.org>
// SPDX-License-Identifier: MIT

package f3

import (
	"time"
)

type Release struct {
	Common
	TagName         string          `json:"tag_name"`
	TargetCommitish string          `json:"target_commitish"`
	Name            string          `json:"name"`
	Body            string          `json:"body"`
	Draft           bool            `json:"draft"`
	Prerelease      bool            `json:"prerelease"`
	PublisherID     *Reference      `json:"publisher_id"`
	Assets          []*ReleaseAsset `json:"assets"`
	Created         time.Time       `json:"created"`
}

func (o Release) GetCmpIgnoreFields() []string {
	return append(o.Common.GetCmpIgnoreFields(), ".Created")
}

func (o *Release) GetReferences() References {
	references := o.Common.GetReferences()
	return append(references, o.PublisherID)
}

func (o *Release) Clone() Interface {
	clone := &Release{}
	*clone = *o
	return clone
}
