// Copyright Earl Warren <contact@earl-warren.org>
// Copyright Loïc Dachary <loic@dachary.org>
// SPDX-License-Identifier: MIT

package f3

import (
	"context"
)

const (
	RepositoryNameDefault = "vcs"
	RepositoryNameWiki    = "vcs.wiki"
)

var nameToID = map[string]int64{
	RepositoryNameDefault: 1,
	RepositoryNameWiki:    2,
}

// var RepositoryNames = []string{RepositoryNameDefault, RepositoryNameWiki}

var RepositoryNames = []string{RepositoryNameDefault}

type Repository struct {
	Common

	Name      string
	FetchFunc func(ctx context.Context, destination string) `json:"-"`
}

func (r *Repository) Clone() Interface {
	clone := &Repository{}
	*clone = *r
	return clone
}

func (r *Repository) GetCmpIgnoreFields() []string {
	return []string{".FetchFunc"}
}

func RepositoryDirname(name string) string {
	return "git" + name
}
